
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import java.io.*;

public class MySAXEventGeneratorReader extends DefaultHandler {

static public void main(String[] args) throws Exception {

        System.out.println("\nVersion 1.0 of MySAXEventGeneratorReader \n");

		//Get the SAX Parser
		MySAXEventGenerator mySAXEventGenerator = new MySAXEventGenerator();

		/*Attach ContentHandler - the callbacks like startDocument,startElement etc. are o
		 overridden by the setContentHandler to trap them into user code*/
        mySAXEventGenerator.setContentHandler(new MySAXEventGeneratorReader());

		File f = new File("SampleMailMessage.txt");
		FileReader fr = new FileReader(f);
		BufferedReader br = new BufferedReader(fr);
		InputSource inputSource = new InputSource(br);

		/*Parse an XML document - the document is read and overriden callbacks in the MySAXEventGeneratorReader are invoked*/
		try{
					/*Parse an XML document - the document is read and overridden callbacks in the MySAXEventGeneratorReader are invoked*/
			        mySAXEventGenerator.parse(inputSource);
				}
				catch (SAXParseException saxException) {
							/* If there are errors in XML data are trapped and location is displayed*/
							System.out.println("\n\nError in data.xml at line:"+saxException.getLineNumber()+"("+saxException.getColumnNumber()+")\n");
							System.out.println(saxException.toString());
						}
				catch (SAXException saxEx) {
							/* If there are errors in XML data, the detailed message of the exception is displayed*/
							System.out.println(saxEx.getMessage());
				}


    } //End of main

    public void startDocument()
		    {
		        System.out.println("\n Start Document: -----Reading SampleMailMessage with MySAXEventGeneratorReader------\n");
		    }

		    public void startElement(String namespaceURI, String localName,
		                             String qualifiedName, Attributes elementAttributes)
		    {
		        System.out.println("Start Element-> "+qualifiedName);
		    }

			public void characters(char[] ch, int start, int length)
			{
				System.out.println("Characters: " + new String(ch,start,length));
			}

		    public void endElement(String namespaceURI, String localName,
		                             String qualifiedName)
		    {
		        System.out.println("End Element-> "+qualifiedName);
		    }

		    public void endDocument()
		    {
		        System.out.println("\n End Document: ----------------Finished Reading the document---------------------\n");
    }

}