
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.w3c.dom.Document;
import org.w3c.dom.DOMException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.stream.StreamResult;
import java.io.*;

public class MyXSLTTransformer
{

    static Document document;

    public static void main (String argv [])
    {


        DocumentBuilderFactory factory =
            DocumentBuilderFactory.newInstance();


        try {
            File stylesheet = new File("CarParts.xsl");
            File datafile   = new File("CarParts.xml");

            DocumentBuilder builder = factory.newDocumentBuilder();
            document = builder.parse(datafile);

            // Use a Transformer for output
            TransformerFactory tFactory =
                TransformerFactory.newInstance();
            StreamSource stylesource = new StreamSource(stylesheet);
            Transformer transformer = tFactory.newTransformer(stylesource);

            DOMSource source = new DOMSource(document);
            StreamResult result = new StreamResult(System.out);
            transformer.transform(source, result);

       } catch (SAXParseException saxException) {
	   	  					/* If there are errors in XML data are trapped and location is displayed*/
	   	  					System.out.println("\n\nError in CarParts.xml at line:"+saxException.getLineNumber()+"("+saxException.getColumnNumber()+")\n");
	   	  					System.out.println(saxException.toString());
	   	  				}
	   	  		catch (SAXException saxEx) {
	   	  							/* If there are errors in XML data, the detailed message of the exception is displayed*/
	   	  							System.out.println(saxEx.getMessage());
	   	  			}

	   	  		catch (ParserConfigurationException pce) {
	   	  		      // Parser with specified options can't be built
	   	  		      pce.printStackTrace();
	   	  			}
	   	  		catch (IOException ioe) {
	   	  		      // I/O error
	   	        ioe.printStackTrace();
	   	  		}
	   			catch (TransformerConfigurationException tcex)
	   			{
	   				System.out.println(tcex.getMessageAndLocation());
	   			}
	   			catch (TransformerException te)
	   			{
	   				System.out.println(te.getMessageAndLocation());
	   		}


    } // main

}
