import javax.xml.soap.*;
import javax.xml.messaging.URLEndpoint;
//import java.util.*;
import java.io.*;

public class MyJAXMClient{

    public static void main(String[] args) {
        try {

            // Create the connection and the message factory.
		    SOAPConnectionFactory scf = SOAPConnectionFactory.newInstance();
            SOAPConnection connection = scf.createConnection();

            // Create a message
            MessageFactory msgFactory = MessageFactory.newInstance();

            SOAPMessage msg = msgFactory.createMessage();

            // Get the SOAP envelope in the message
            SOAPEnvelope envelope = msg.getSOAPPart().getEnvelope();

            // Get the soap body
            SOAPBody body = envelope.getBody();

			//Add Body element
			Name bodyName = envelope.createName("find_business", "","urn:uddi-org:api");
			Name genericAttribute = envelope.createName("generic");
			Name maxRowsAttribute = envelope.createName("maxRows");
			SOAPBodyElement bodyElement = body.addBodyElement(bodyName);

			// Add attributes

           	bodyElement.addAttribute(genericAttribute, "1.0");
           	bodyElement.addAttribute(maxRowsAttribute, "100");


           //Adding Child Elements and its text node
           Name companyName = envelope.createName("name");
           bodyElement.addChildElement(companyName).addTextNode(args[1]);

		   msg.saveChanges();

		   System.out.println("The Outgoing SOAP Message :\n");
		   msg.writeTo(System.out);


           URLEndpoint endpoint
                = new URLEndpoint("http://www-3.ibm.com/services/uddi/testregistry/inquiryapi");



           SOAPMessage reply = connection.call(msg, endpoint);

          System.out.println("\n Received reply from: "+endpoint);

            reply.writeTo(System.out);

            connection.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}






